{
	TCryptLabel

	This component allow you to encrypt caption in TLabel. It's useful when you
	don't want that someone will read or change some text in your EXE file.
	For example, you wrotte in About box your name,address etc. and you must be
	sure that nobody will change it. Encrypted text is "invisible" in EXE file
	but in your windows it looks normal.

	Procedure to encrypt&decrypt (only one) is very simple, so you can override it.

	Sorry if my English wasn't clear!

	****************************
	 THIS PROGRAM IS FREEWARE!!
	****************************

	Autor:
		Grzegorz Anio (Greg Angel)
		Gliwice, ul.Poniatowskiego 12/3
		44-106 Gliwice, POLAND

	Contact via Internet:
		gangel@zeus.polsl.gliwice.pl          (Silesian Technical School)
		http://zeus.polsl.gliwice.pl/~gangel	  (page in Polish only!)

	(October 1997)
}
unit clabel;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls;

type
	TCryptLabel = class(TLabel)
	private
		fKey : Byte;	{ key for crypt method }

		procedure DefaultHandler(var Message); override;
			{ override process for changing caption -
				new text should be crypted }

		procedure SetKey(AKey:Byte);
			{ manual change the key value }
		procedure NewKey;
			{ calculate a new key value }

		function GetLabelText: string; override;
			{ override process for getting actual caption -
				it's should be decrypted first }

		function CryptStr(const S:String):String;
			{ default encrypt&decrypt method }

	protected
		{ you can override these methods in the future! }
		function Encrypt(const S: String; AKey:Word): String; virtual;
		function Decrypt(const S: String; AKey:Word): String; virtual;

	public
		constructor Create(AOwner:TComponent); override;
			{ constructor prepare a uniqe key value }
			
	published
		property Key:Byte read FKey write SetKey;
			{ key value must be published property,
				in order that Delphi will remember it }
	end;

procedure Register;

implementation

const
	C1 = 52845;
	C2 = 22719;

function TCryptLabel.CryptStr(const S:String):String;
var
	i : Integer;
begin
	result:='';
	for i:=1 to Length(s) do
		result:=result+Chr( Ord(s[i]) xor i xor FKey);
end;

function TCryptLabel.Encrypt(const S: String; AKey:Word): String;
begin
	result:=CryptStr(s);
end;

function TCryptLabel.Decrypt(const S: String;AKey:Word): String;
begin
	result:=CryptStr(s);
end;

constructor TCryptLabel.Create(AOwner:TComponent);
begin
	inherited Create(AOwner);
	NewKey;
end;

procedure TCryptLabel.SetKey(AKey:Byte);
var
	txt : String;
begin
	txt:=Caption;
	FKey:=AKey;
	Caption:=txt;
end;

procedure TCryptLabel.NewKey;
var
	txt : String;
begin
	txt:=Caption;
	fKey:=Random($FE)+1;
	Caption:=txt;
end;

procedure TCryptLabel.DefaultHandler(var Message);
var
	p : array[0..200] of char;
	s : String;
begin
	inherited DefaultHandler(message);
	with TMessage(Message) do
		case Msg of
			WM_SETTEXT:
				if not (csLoading in ComponentState) then
				begin
					StrCopy(p,PChar(LParam));
					if(p[0]=#0) then NewKey;
					StrPCopy(p,Encrypt(StrPas(p),FKey));

					lParam:=LongInt(@p);
					wParam:=StrLen(p);
					inherited DefaultHandler(message);
					msg:=CM_TEXTCHANGED;
					lParam:=0;
					wParam:=0;
					inherited DefaultHandler(message);
				end;
		end;
end;

function TCryptLabel.GetLabelText: string;
var
	s : String;
begin
	s:=inherited GetLabelText;
	s:=Decrypt(s,FKey);
	result:=s;
end;

procedure Register;
begin
	RegisterComponents('Samples', [TCryptLabel]);
end;

initialization
begin
	Randomize;
end;

end.
